using Fuse.Scripting;
using Uno;
using Uno.Threading;
using Uno.UX;
using Uno.Permissions;
using Fuse;
using Uno.Compiler.ExportTargetInterop;
using Uno.Collections;
using Fuse.Triggers.Actions;

[ForeignInclude(Language.Java, "android.content.pm.PackageManager")]
[ForeignInclude(Language.Java, "android.support.v4.app.ActivityCompat")]
[ForeignInclude(Language.Java, "com.fuse.Activity")]

[UXGlobalModule]
public class Permission : NativeModule
{
    static readonly Permission _instance;

    public Permission()
    {
        if (_instance != null)
            return;
        _instance = this;
        Resource.SetGlobalKey(_instance, "Permission");
        AddMember(new NativeFunction("AskMicroPhonePermission", (NativeCallback)AskMicroPhonePermission));
    }

    object AskMicroPhonePermission(Context c, object[] args)
    {
        if defined(Android)
        {
                var permissionPromise = Permissions.Request(Permissions.Android.RECORD_AUDIO);
                permissionPromise.Then(OnPermitted, OnRejected);
        }
        return null;
    }

    extern(Android) void Reject(Exception e)
    {
        debug_log("Could not acquire read-write data permissions: " + e.Message);
    }

    extern(Android) void OnPermitted(PlatformPermission permission)
    {

    }

    extern(Android) void OnRejected(Exception e)
    {

    }
}
